unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdGlobal,IdBaseComponent, IdComponent, IdTCPServer, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Serv: TIdTCPServer;
    Memo1: TMemo;
    Edit1: TEdit;
    Timer1: TTimer;
    procedure ServConnect(AThread: TIdPeerThread);
    procedure ServExecute(AThread: TIdPeerThread);
    procedure Timer1Timer(Sender: TObject);
    procedure ServDisconnect(AThread: TIdPeerThread);

  private
    { Private declarations }
  public
  procedure TimeGo(Go:boolean);
    { Public declarations }
  end;

var
  Form1: TForm1;
  Client1:Cardinal;
implementation

{$R *.dfm}

procedure TForm1.TimeGo(Go:boolean);
begin
Form1.Edit1.Clear;
Form1.Timer1.Enabled:=Go;
end;

procedure TForm1.ServConnect(AThread: TIdPeerThread);
begin
Memo1.Lines.Add(TimeToStr(Now)+'*************************** ');
Memo1.Lines.Add(TimeToStr(Now)+' Connect client  ... ');
Memo1.Lines.Add(TimeToStr(Now)+' ['+IntToStr(AThread.ThreadID)+'] is client threadID ');
Memo1.Lines.Add(TimeToStr(Now)+' ['+IntToStr(AThread.Handle)+'] is client thread handle');

end;

procedure TForm1.ServExecute(AThread: TIdPeerThread);
var
InS:string;
begin

if (not AThread.Connection.ClosedGracefully) then
begin
InS:=AThread.Connection.CurrentReadBuffer;
if Length(InS)>0 then SetLength(InS,Length(InS)-1);
Memo1.Lines.Add(TimeToStr(Now)+' ['+ IntToStr(AThread.Handle)+'] ['+InS+']');

If Pos('Go',InS)=1   then TimeGo(true);
If Pos('Stop',InS)=1 then TimeGo(false);
If Pos('Buy',InS)=1  then AThread.Connection.Disconnect;
end;
end;
procedure TForm1.Timer1Timer(Sender: TObject);
begin
Edit1.Text:=TimeToStr(Now);
end;


procedure TForm1.ServDisconnect(AThread: TIdPeerThread);
begin
Memo1.Lines.Add(TimeToStr(Now)+'> Disconnect client  ... ');
Memo1.Lines.Add(TimeToStr(Now)+' ['+IntToStr(AThread.ThreadID)+'] is client threadID ');
Memo1.Lines.Add(TimeToStr(Now)+' ['+IntToStr(AThread.Handle)+'] is client thread handle');
Memo1.Lines.Add(TimeToStr(Now)+'*************************** ');
end;

end.
